#include <stdbool.h>
#include <stddef.h>
#include <sys/mman.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <stdint.h>

#include "align.h"
#include "./chunk.h"

int add_new_block(chunk_t* chunk, size_t size, void *prev, void *next, bool is_used)
{
	static int	block_id = 0;
	void		*new_block;
	chunk_t		previous_chunk;

	// TODO check with getrlimit()

	new_block = mmap(NULL, size + ALIGN_MARGING + CHUNK_SIZE, PROT_READ | PROT_WRITE, MAP_PRIVATE | MAP_ANONYMOUS, -1, 0);

	init_chunk(chunk, size + ALIGN_MARGING - get_align_increment(new_block + CHUNK_SIZE), block_id, prev, new_block, next, is_used);
	
	if (prev != NULL)
	{
		chunk_read(prev, &previous_chunk);
		previous_chunk.next = chunk->current;
		chunk_write(&previous_chunk);
	}

	block_id++;

	return 0;
}